package xmlchecker;

import xmlchecker.XMLTreeNode;
import xmlchecker.FontScaler;

import java.awt.Component;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.tree.TreeCellRenderer;
import javax.swing.ImageIcon;

/**
  Darstellung der XMLNode im Baum
*/
public class XMLTreeRenderer extends JLabel implements TreeCellRenderer{
  private JLabel lblComp;
  private JTextArea txtComp;
  private ImageIcon icoElement, icoAttribute, icoPi;

/**
  Konstruktor
  @param   scaler   Skalierung fr die Texte im Baum
*/
  public XMLTreeRenderer(FontScaler scaler){
    this.lblComp = new JLabel();
    this.txtComp = new JTextArea();
    scaler.add(lblComp);
    scaler.add(txtComp);
    this.txtComp.setBackground(lblComp.getBackground());
    try{
      this.icoElement = new ImageIcon(ClassLoader.getSystemResource("xmlchecker/icon/element.gif"));
      this.icoAttribute = new ImageIcon(ClassLoader.getSystemResource("xmlchecker/icon/attribute.gif"));
      this.icoPi = new ImageIcon(ClassLoader.getSystemResource("xmlchecker/icon/pi.gif"));
    }catch(Exception ex){
    }
  }
/**
  Liefert die fr den Knoten anzuzeigende Komponente
*/
  public Component getTreeCellRendererComponent(JTree tree, Object val, boolean sel, boolean exp, boolean leaf, int row, boolean hasFocus){
    JComponent cellComp = null;
    String txt = String.valueOf(val);
    try{
      XMLTreeNode node = (XMLTreeNode)val;
      switch(node.getType()){
        case XMLTreeNode.ELEMENT:
          this.lblComp.setIcon(this.icoElement);
          this.lblComp.setText(txt);
          cellComp = lblComp;
          break;
        case XMLTreeNode.ATTRIBUTE:
          this.lblComp.setIcon(this.icoAttribute);
          this.lblComp.setText(txt);
          cellComp = lblComp;
          break;
        case XMLTreeNode.PI:
          this.lblComp.setIcon(this.icoPi);
          this.lblComp.setText(txt);
          cellComp = lblComp;
          break;
        case XMLTreeNode.CHARACTERS:
          this.txtComp.setText(txt);
          cellComp = txtComp;
          break;
        default:
          this.lblComp.setIcon(null);
          this.lblComp.setText(txt);
          cellComp = lblComp;
      }
    }catch(Exception ex){
    }
    cellComp.setOpaque(hasFocus);
    return cellComp;
  }
}
